import java.io.*;
import java.security.*;
import java.security.spec.*;
import java.security.interfaces.*;

public class UPServerKeyPair {

    private PublicKey           upserverPublicKey;
    private PrivateKey          upserverPrivateKey;
    private byte[]              upserverEncodedPublicKey;

    public UPServerKeyPair() {
        try {
            // UPServer's public/private keys generator
            // This will be replaced by reading keys from keys repository
            KeyPairGenerator upserverKeyGen = KeyPairGenerator.getInstance("DSA");
            upserverKeyGen.initialize(1024, new SecureRandom());
            KeyPair kPair = upserverKeyGen.generateKeyPair();
            upserverPublicKey = kPair.getPublic();
            upserverPrivateKey = kPair.getPrivate();
            upserverEncodedPublicKey = upserverPublicKey.getEncoded();
        } catch (Exception ex) {
            System.err.println("UPServerKeyPair Exception-> " + ex);
        }
    }

    public byte[] getEncodedPublicKey() {
        return this.upserverEncodedPublicKey;
    }

    public PublicKey getPublicKey() {
        return this.upserverPublicKey;
    }

    public PrivateKey getPrivateKey() {
        return this.upserverPrivateKey;
    }
}
